/*********
  Rui Santos
  Complete project details at http://randomnerdtutorials.com  
*********/
// Load Wi-Fi library
#include <WiFi.h>
#include <WebServer.h>

// Replace with your network credentials
//const char* ssid     = "REPLACE_WITH_YOUR_SSID";
//const char* password = "REPLACE_WITH_YOUR_PASSWORD";

// Set web server port number to 80
WiFiServer server(80);

// Variable to store the HTTP request
String header;

// Auxiliar variables to store the current output state
String output26State = "off";
String output27State = "off";
String output28State = "off";
String output26StateL = "";
String output27StateL = "";
String output28StateL = "";

// Assign output variables to GPIO pins
const int output26 = 18;//9
const int output27 = 21;//6
const int output28 = 19;//8
//const int buttonPin = 2;
const int VOLT_ADC_PIN26=27;//11
const int VOLT_ADC_PIN27=26;//10
const int VOLT_ADC_PIN28=32;//7


// Current time
unsigned long currentTime = millis();
// Previous time
unsigned long previousTime = 0;        
// Define timeout time in milliseconds (example: 2000ms = 2s)
const long timeoutTime = 2000;
// variables will change:
int buttonState26 = 0;         // variable for reading the pushbutton status
int buttonState27 = 0; 
int buttonState28 = 0; 

void setup() {
  Serial.begin(115200);
  
  // Initialize the output variables as outputs
  pinMode(output26, OUTPUT);
  pinMode(output27, OUTPUT);
  pinMode(output28, OUTPUT);
  pinMode(VOLT_ADC_PIN26, INPUT);
  pinMode(VOLT_ADC_PIN27, INPUT);
  pinMode(VOLT_ADC_PIN28, INPUT);
//  pinMode(buttonPin, INPUT);
 
  // Set outputs to LOW
 // digitalWrite(output26, LOW);
 // digitalWrite(output27, LOW);

  // Connect to Wi-Fi network with SSID and password
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();
}

void loop(){
  WiFiClient client = server.available();   // Listen for incoming clients
  delay(100);

  
  if (client) {                             // If a new client connects,


      
    currentTime = millis();
    previousTime = currentTime;
    Serial.println("New Client.");          // print a message out in the serial port
    String currentLine = "";                // make a String to hold incoming data from the client
    while (client.connected() && currentTime - previousTime <= timeoutTime) {
      currentTime = millis();
      // loop while the client's connected
      if (client.available()) {             // if there's bytes to read from the client,
        char c = client.read();             // read a byte, then
       /// Serial.write(c);         i have comment out for serial only           // print it out the serial monitor
        header += c;
        if (c == '\n') {                    // if the byte is a newline character
          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          if (currentLine.length() == 0) {
            // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
            // and a content-type so the client knows what's coming, then a blank line:
  // checking if header is valid

  if(header.indexOf("YXNocmFmOmFzaHJhZjExMw==") >= 0) {  

            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println();

            buttonState26 = digitalRead(VOLT_ADC_PIN26);
            buttonState27 = digitalRead(VOLT_ADC_PIN27); 
            buttonState28 = digitalRead(VOLT_ADC_PIN28); 
            
            // turns the GPIOs on and off
            if (header.indexOf("GET /26/on") >= 0) {
               //############## Start Code for AC Voltage detection
               Serial.println("When ON:");
              output26State = "on";
              digitalWrite(output26, HIGH);
            } else if (header.indexOf("GET /26/off") >= 0) {
              //############## Start Code for AC Voltage detection
              Serial.println("When OFF:");
              output26State = "off";
              digitalWrite(output26,LOW);
            } else if (header.indexOf("GET /27/on") >= 0) {
              Serial.println("GPIO 27 on");
              output27State = "on";
              digitalWrite(output27, HIGH);
            } else if (header.indexOf("GET /27/off") >= 0) {
              Serial.println("GPIO 27 off");
              output27State = "off";
              digitalWrite(output27, LOW);


            } else if (header.indexOf("GET /28/on") >= 0) {
              Serial.println("GPIO 28 on");
              output28State = "on";
              digitalWrite(output28, HIGH);
            } else if (header.indexOf("GET /28/off") >= 0) {
              Serial.println("GPIO 28 off");
              output28State = "off";
              digitalWrite(output28, LOW);

            } else if (header.indexOf("GET /26/RemoteL0") >= 0) {
              Serial.println("GPIO 26 Light Remote status off");

              if (buttonState26==1 )
                { output26StateL = "RLight 26 ON"; }
              else if (buttonState26==0 )
               { output26StateL = "RLight 26 OFF"; }
                Serial.println(output26StateL);
            } else if (header.indexOf("GET /27/RemoteL0") >= 0) {
              Serial.println("GPIO 27 Light Remote status off");

              if (buttonState27==1 )
                { output27StateL = "RLight 27 ON"; }
              else if (buttonState27==0 )
               { output27StateL = "RLight 27 OFF"; }
                Serial.println(output27StateL);
           }

             else if (header.indexOf("GET /28/RemoteL0") >= 0) {
              Serial.println("GPIO 28 Light Remote status off");

              if (buttonState28==1 )
                { output28StateL = "RLight 28 ON"; }
              else if (buttonState28==0 )
               { output28StateL = "RLight 28 OFF"; }
                Serial.println(output28StateL);
            } 

              
            // Display the HTML web page
            client.println("<!DOCTYPE html><html>");
            client.println("<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">");
            client.println("<link rel=\"icon\" href=\"data:,\">");
            // CSS to style the on/off buttons 
            // Feel free to change the background-color and font-size attributes to fit your preferences
            client.println("<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
            client.println(".button { background-color: #4CAF50; border: none; color: white; padding: 16px 40px;");
            client.println("text-decoration: none; font-size:20px; margin: 2px; cursor: pointer;}");

            client.println(".button1 { background-color: #4CAF50; border: none; color: white; padding: 16px 40px;");
            client.println("text-decoration: none; font-size: 10px; margin: 1px; cursor: pointer;}");
            
            
            client.println(".button2 {background-color: #555555;}</style></head>");
            
            // Web Page Heading
            client.println("<body><h1>ESP32: Relay Switch 220v AC On/Off</h1>");

         
            // Display current state, and ON/OFF buttons for GPIO 26  
           // client.println("<p>GPIO 26 - State " + output26State + "</p>");
           /// client.println("<p>GPIO 26 - State " + output26State + ":");
          client.println("<p>Fan -" + output26State + ":");
   
            // If the output26State is off, it displays the ON button  
            if (output26State=="off")     {
        
             //client.println("<p><a href=\"/26/on\"><button class=\"button button\">ON</button></a></p>");
              client.println("<a href=\"/26/on\"><button class=\"button\">ON/OFF</button></a>");
              client.println("<a href=\"/26/RemoteL0\"><button class=\"button1\">State-L1</button></a>->" + output26StateL + "</p>");
              
            } else {
              //client.println("<p><a href=\"/26/off\"><button class=\"button button\">ON/OFF</button></a></p>");
              client.println("<a href=\"/26/off\"><button class=\"button button2\">ON/OFF</button></a>");
               client.println("<a href=\"/26/RemoteL0\"><button class=\"button1\">State-L1</button></a>->" + output26StateL + "</p>");
            } 
               
            // Display current state, and ON/OFF buttons for GPIO 27  
            //client.println("<p>GPIO 27 - State " + output27State + "</p>");
            /// client.println("<p>GPIO 27 - State " + output27State + ":");
             client.println("<p>Light1-" + output27State + ":");
          /*       if (buttonState27==1) {
              client.println(" Last Status:ON");
            } else {
            client.println(" Last Status:OFF");
            }
            */
            
          // If the output27State is off, it displays the ON button       
            if (output27State=="off") {
              client.println("<a href=\"/27/on\"><button class=\"button\">ON/OFF</button></a>");
              client.println("<a href=\"/27/RemoteL0\"><button class=\"button1\">State-L2</button></a>->" + output27StateL + "</p>");
            } else {
              client.println("<a href=\"/27/off\"><button class=\"button button2\">ON/OFF</button></a>");
              client.println("<a href=\"/27/RemoteL0\"><button class=\"button1\">State-L2</button></a>->" + output27StateL + "</p>");
            }
             client.println("<p>Light2-" + output28State + ":");
         // If the output28State is off, it displays the ON button       
            if (output28State=="off") {
              client.println("<a href=\"/28/on\"><button class=\"button\">ON/OFF</button></a>");
              client.println("<a href=\"/28/RemoteL0\"><button class=\"button1\">State-L3</button></a>->" + output28StateL + "</p>");
            } else {
              client.println("<a href=\"/28/off\"><button class=\"button button2\">ON/OFF</button></a>");
              client.println("<a href=\"/28/RemoteL0\"><button class=\"button1\">State-L3</button></a>->" + output28StateL + "</p>");
            }
                
            client.println("</body></html>");
            
            // The HTTP response ends with another blank line
            client.println();
            // Break out of the while loop
            break;
} /// just added for authentication call
 
          else { 
client.println("HTTP/1.1 401 Unauthorized");
client.println("WWW-Authenticate: Basic realm=\"Secure\"");
client.println("Content-Type: text/html");
client.println();
client.println("<html>Authentication failed</html>");
} 
          
          } else { // if you got a newline, then clear currentLine
            currentLine = "";
          }
        } else if (c != '\r') {  // if you got anything else but a carriage return character,
          currentLine += c;      // add it to the end of the currentLine
        }
      }
    }
    // Clear the header variable
    header = "";
    // Close the connection
    client.stop();
    Serial.println("Client disconnected.");
    Serial.println("");
  }
}
